<!DOCTYPE html>
<html>
<head>
	<meta charset="utf-8">
	 <meta name="viewport" content="width=device-width, initial-scale=1.0">
	<title>Bootstrap Flex</title>

	<!-- Bootstrap -->
	<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/css/bootstrap.min.css" integrity="sha384-xOolHFLEh07PJGoPkLv1IbcEPTNtaed2xpHsD9ESMhqIYd0nLMwNLD69Npy4HI+N" crossorigin="anonymous">
</head>

<body>
	<!-- Main container -->
	<div class="container-fluid text-center">
		<h1>Bootstrap Flex</h1>
		<p>Use the d-flex (d- is for dipslay property) class to create a flex container and transform direct children in to flex item.</p>

		<h2>Centering Elements</h2>

		<!-- Parent container using d-flex class -->
		<div style="height: 500px;" class="bg-secondary p-3 d-flex justify-content-center align-items-center flex-column">

			<!-- Child element which will be converted in to flex item if the parent element has a d-flex class -->
			<div class="h-25 p-3 bg-success">Flex Item A</div>
			<div class="h-25 p-3 bg-warning">Flex Item B</div>
			<div class="h-25 p-3 bg-danger">Flex Item C</div>
		</div>

		<h2>Flex Row</h2>
		<!-- By default, parent element is in flex-row property -->
		<div class="d-flex bg-dark p-3 flex-row">
			<div class="p-3 bg-success">Flex Item A</div>
			<div class="p-3 bg-warning">Flex Item B</div>
			<div class="p-3 bg-danger">Flex Item C</div>			
		</div>

		<h2>Flex Row Reverse</h2>
		<div class="d-flex bg-dark p-3 flex-row-reverse">
			<div class="h-25 p-3 bg-success">Flex Item A</div>
			<div class="h-25 p-3 bg-warning">Flex Item B</div>
			<div class="h-25 p-3 bg-danger">Flex Item C</div>	
		</div>

		<h2>Creating Space Between Elements</h2>
		<div class="d-md-flex bg-dark p-3 justify-content-around">
			<div class="h-25 p-3 bg-success">Flex Item A</div>
			<div class="h-25 p-3 bg-warning">Flex Item B</div>
			<div class="h-25 p-3 bg-danger">Flex Item C</div>
		</div>

		<h2>Flexbox with Margin</h2>
		<div class="d-flex bg-dark p-3">
			<div class="p-3 bg-success mr-auto">Flex Item A</div>
			<div class="p-3 bg-warning">Flex Item B</div>
			<div class="p-3 bg-danger">Flex Item C</div>
			<div class="p-3 bg-warning">Flex Item D</div>		
		</div>

		<h2>Nested Flex Elements</h2>
		<!-- Main d-flex parent element -->
		<div class="bg-dark p-3 d-flex d-md-flex d-md-flex d-block">
			<div class="p-3 bg-success mr-auto">Flex item A</div>

			<!-- Child of a child d-flex class -->
			<div class="w-50 d-md-flex justify-content-between d-md-flex d-block">
				<div class="p-3 bg-warning">Flex Item B</div>
				<div class="p-3 bg-danger">Flex Item C</div>
				<div class="p-3 bg-primary">Flex Item D</div>		
			</div>		
		</div>

	<!-- End of the main container  -->
	</div>





<!-- Bootstrap -->
<script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
<script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-Fy6S3B9q64WdZWQUiU+q4/2Lc9npb8tCaSX9FK7E8HnRr0Jz8D6OP9dO5Vg3Q9ct" crossorigin="anonymous"></script>


</body>
</html>